"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const graphql_tools_1 = require("graphql-tools");
const resolvers_explorer_service_1 = require("./services/resolvers-explorer.service");
const scalars_explorer_service_1 = require("./services/scalars-explorer.service");
const type_graphql_1 = require("type-graphql");
let SchemaBuilder = class SchemaBuilder {
    constructor(resolversExplorerService, scalarsExplorerService) {
        this.resolversExplorerService = resolversExplorerService;
        this.scalarsExplorerService = scalarsExplorerService;
    }
    build(options) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const scalars = this.scalarsExplorerService.explore();
                const schema = yield type_graphql_1.buildSchema(Object.assign({ emitSchemaFile: true }, options, { resolvers: ['**/*.undfined.undfiend.js'], scalarsMap: scalars }));
                const resolvers = this.resolversExplorerService.explore();
                graphql_tools_1.addResolveFunctionsToSchema({
                    schema,
                    resolvers,
                });
                return schema;
            }
            catch (e) {
                console.error(e);
            }
        });
    }
};
SchemaBuilder = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [resolvers_explorer_service_1.ResolversExplorerService,
        scalars_explorer_service_1.ScalarsExplorerService])
], SchemaBuilder);
exports.SchemaBuilder = SchemaBuilder;
