"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const type_graphql_1 = require("type-graphql");
require("reflect-metadata");
const decorators_1 = require("type-graphql/helpers/decorators");
const graphql_constants_1 = require("./../graphql.constants");
const param_decorators_1 = require("./param.decorators");
const gql_paramtype_enum_1 = require("../enums/gql-paramtype.enum");
function Arg(name, returnTypeFuncOrOptions, maybeOptions) {
    const argType = type_graphql_1.Arg(name, returnTypeFuncOrOptions, maybeOptions);
    return (target, key, index) => {
        argType(target, key, index);
        const args = Reflect.getMetadata(graphql_constants_1.PARAM_ARGS_METADATA, target.constructor, key) || {};
        const { options } = decorators_1.getTypeDecoratorParams(returnTypeFuncOrOptions, maybeOptions);
        const paramPipes = options.pipes ? options.pipes : [];
        Reflect.defineMetadata(graphql_constants_1.PARAM_ARGS_METADATA, param_decorators_1.assignMetadata(args, gql_paramtype_enum_1.GqlParamtype.ARGS, index, name, ...paramPipes), target.constructor, key);
    };
}
exports.Arg = Arg;
