"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const type_graphql_1 = require("type-graphql");
const gql_paramtype_enum_1 = require("../enums/gql-paramtype.enum");
const graphql_constants_1 = require("../graphql.constants");
const _1 = require(".");
function Args(paramTypeFunction, options) {
    const pipes = typeof paramTypeFunction !== 'function' ? paramTypeFunction : options;
    const typeArgs = typeof paramTypeFunction === 'function'
        ? type_graphql_1.Args(paramTypeFunction)
        : type_graphql_1.Args();
    return (target, key, index) => {
        typeArgs(target, key, index);
        const args = Reflect.getMetadata(graphql_constants_1.PARAM_ARGS_METADATA, target.constructor, key) || {};
        const paramPipes = pipes ? (pipes.pipes ? pipes.pipes : []) : [];
        Reflect.defineMetadata(graphql_constants_1.PARAM_ARGS_METADATA, _1.assignMetadata(args, gql_paramtype_enum_1.GqlParamtype.ARGS, index, undefined, ...paramPipes), target.constructor, key);
    };
}
exports.Args = Args;
