"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const type_graphql_1 = require("type-graphql");
const common_1 = require("@nestjs/common");
const graphql_constants_1 = require("../graphql.constants");
const decorators_1 = require("type-graphql/helpers/decorators");
function FieldResolver(returnTypeFuncOrOptions, maybeOptions) {
    const TypeFieldResolver = type_graphql_1.FieldResolver(returnTypeFuncOrOptions, maybeOptions);
    const { options } = decorators_1.getTypeDecoratorParams(returnTypeFuncOrOptions, maybeOptions);
    return (target, key, descriptor) => {
        TypeFieldResolver(target, key, descriptor);
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_NAME_METADATA, options.name || key)(target, key, descriptor);
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_PROPERTY_METADATA, true)(target, key, descriptor);
    };
}
exports.FieldResolver = FieldResolver;
