"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const decorators_1 = require("type-graphql/helpers/decorators");
const type_graphql_1 = require("type-graphql");
const common_1 = require("@nestjs/common");
const graphql_constants_1 = require("../graphql.constants");
const resolvers_enum_1 = require("../enums/resolvers.enum");
function Mutation(returnTypeFuncOrOptions, maybeOptions) {
    const { options, returnTypeFunc } = decorators_1.getTypeDecoratorParams(returnTypeFuncOrOptions, maybeOptions);
    const typeMutation = type_graphql_1.Mutation(returnTypeFuncOrOptions, maybeOptions);
    return (target, key, descriptor) => {
        typeMutation(target, key, descriptor);
        const name = options.name || undefined;
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_TYPE_METADATA, resolvers_enum_1.Resolvers.MUTATION)(target, key, descriptor);
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_NAME_METADATA, name)(target, key, descriptor);
    };
}
exports.Mutation = Mutation;
