"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const resolvers_enum_1 = require("../enums/resolvers.enum");
const type_graphql_1 = require("type-graphql");
const decorators_1 = require("type-graphql/helpers/decorators");
const graphql_constants_1 = require("../graphql.constants");
const common_1 = require("@nestjs/common");
function Query(returnTypeFuncOrOptions, maybeOptions) {
    const typeQuery = type_graphql_1.Query(returnTypeFuncOrOptions, maybeOptions);
    const { options } = decorators_1.getTypeDecoratorParams(returnTypeFuncOrOptions, maybeOptions);
    return (target, key, descriptor) => {
        typeQuery(target, key, descriptor);
        const name = options.name || undefined;
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_TYPE_METADATA, resolvers_enum_1.Resolvers.QUERY)(target, key, descriptor);
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_NAME_METADATA, name)(target, key, descriptor);
    };
}
exports.Query = Query;
