"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const type_graphql_1 = require("type-graphql");
const common_1 = require("@nestjs/common");
const graphql_constants_1 = require("../graphql.constants");
function Resolver(objectTypeOrTypeFuncOrMaybeOptions, maybeOptions) {
    const typeResolver = type_graphql_1.Resolver(objectTypeOrTypeFuncOrMaybeOptions, maybeOptions);
    const objectTypeOrTypeFunc = typeof objectTypeOrTypeFuncOrMaybeOptions === 'function'
        ? objectTypeOrTypeFuncOrMaybeOptions
        : undefined;
    const options = (typeof objectTypeOrTypeFuncOrMaybeOptions === 'function'
        ? maybeOptions
        : objectTypeOrTypeFuncOrMaybeOptions) || {};
    return (target, key, descriptor) => {
        typeResolver(target);
        const getObjectType = objectTypeOrTypeFunc
            ? objectTypeOrTypeFunc.prototype
                ? () => objectTypeOrTypeFunc
                : objectTypeOrTypeFunc
            : () => {
                throw new Error(`No provided object type in '@Resolver' decorator for class '${target.name}!'`);
            };
        const name = getObjectType().name;
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_TYPE_METADATA, name)(target, key, descriptor);
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_NAME_METADATA, name)(target, key, descriptor);
    };
}
exports.Resolver = Resolver;
