"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const resolvers_enum_1 = require("../enums/resolvers.enum");
const graphql_constants_1 = require("../graphql.constants");
function createResolverDecorator(resolver) {
    return (name) => (target, key, descriptor) => {
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_TYPE_METADATA, resolver || name)(target, key, descriptor);
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_NAME_METADATA, name)(target, key, descriptor);
    };
}
exports.createResolverDecorator = createResolverDecorator;
function createDelegateDecorator(propertyName) {
    return (target, key, descriptor) => {
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_NAME_METADATA, propertyName)(target, key, descriptor);
        common_1.ReflectMetadata(graphql_constants_1.RESOLVER_DELEGATE_METADATA, propertyName)(target, key, descriptor);
    };
}
exports.createDelegateDecorator = createDelegateDecorator;
exports.Subscription = createResolverDecorator(resolvers_enum_1.Resolvers.SUBSCRIPTION);
